# Lab 1

## Exercise 1 (Czech Transcription)

```
SEBRAL ZE ZEMĚ TUŽKU.       s e b r a l  z e  z e m nj e  t u sh k u .
KDO SEBRAL TUŽKU?       g d o  s e b r a l  t u sh k u ?
NA SHLEDANOU!       n a  z h l e d a n ow 
       
ONA JSI Z FRANCIE.       o n a  j s i  z  f r a n c i e .
ON JSI Z ITALIE.       o n  j s i  z  i t a l i e .
MUSÍM JÍT K DOKTOROVI.       m u s ii m  j ii t  k  d o k t o r o v i .
       
RABBI LÖW BYLO SLAVNÝ PRAŽSKÝ OBYVATEL.       r a b b i  l o v  b i l o  s l a v n ii  p r a sh s k ii  o b i v a t e l .
```

The first block investigates intra-word assimilation. The 〈ž〉 graph
in “tužku” is correctly rendered as voiceless [ʃ] due to the influence
of the voiceless [k] afterwards. Similarly, the 〈k〉 graph in “kdo”
is correctly rendered as voiced [g]. The digraph 〈sh〉in „shledanou“
is rendered as the Moravian variant [zɦ], which is correct. Another
correct rendering would have been the Bohemian pronunciation [sx]. We
can conclude that the script actually handles intra-word assimilation
correctly!

The second block investigates inter-word assimilation. In my
understanding, 〈z〉 should be devoiced before a word starting with a
voiceless consonant or a vowel. This rule is not observed in the
transcriptions of “z France” and “z Italie”. Also, the 〈k〉 should
become voiced before a word starting with a voiced consonant like
“doktorovi”, which is not done in the transcription, either.

The final sentence includes the German title and name “Rabbi Löw”. The
transcription is definitely wrong in emitting two consecutive plosives
[bb] instead of only one. It renders 〈w〉 as [v], which might seem
correct at first, but is actually not the correct German
pronunciation, which would devoice word-final consonants resulting in
[f] in this case. (I think that’s common in Czech, as well?) It also
renders 〈ö〉, which is pronounced [ø] in German, as “o”, which is
probably supposed to be IPA [ɔ]. This is somewhat close and might be
how Czech people actually pronounce the name, so it might be correct.


## Exercise 2 (Example conversations)

### Conversation 1

```
Člověk: „Hej, hudební odborník, chci se poslouchat hudbu!“
Robot: „Dobré, udajte žánr!“
Člověk: „Nevím. Něco jako Led Zeppelin.“
Robot: „Přehrám rockovou hudbu z sedmdesátych letům. To je dobré?“
Člověk: „Ano, fajn.“
```

### Conversation 2

```
Člověk: „Hej, hudební odborník, znáte skupinu Master’s Hammer?“
Robot: „Ovšem znám. Master’s Hammer je Česká black metalová skupina založena v roce 1987.“
Člověk: „Děkuji! Co je její nejznámější album?“
Robot: „První deska ‚Ritual‘ je považován legendární rané black metalové album.“
Člověk: „To je ohromné! Master’s Hammer je ještě činné?“
Robot: „Ano, je jěstě činné. Její poslední album je ‚Fascinator‘.“
Člověk: „Jsou jiné slavné České black metalové skupiny?“
Robot: „Ovšem jsou. Napřiklad jsou Root, Törr nebo mladá pražská skupina Cult of Fire.“
Člověk: „Děkuji mnohokrát! Prosím, přehrájte Cult of Fire.“
Robot: „Přehrám píseň ‚Vltava‘ skupiny Cult of Fire.“
```

### Conversation 3

```
Člověk: „Hej, hudební odborník, kdy byl vynalezen klavír?“
Robot: „Klavír byl vynalezen kolem roku 1700.“
Člověk: „Děkuji!“
```

### Conversation 4

```
Člověk: „Hej, hudební odborník, znáte novou Prazskou kapelu Cloudy Babies?“
Robot: „Tu kapelu bohužel neznám. Jakou hudbu dělají?“
Člověk: „Myslím, že to je minimalistická hudba.“
Robot: „Rozumím. A kdy ta skupina byl zalažena?“
Člověk: „Letos. A už vydaly EP!“
Robot: „Rozumím. Děkuji!“
```

### Conversation 5

```
Člověk: „Hej, hudební odborník, kdo byl lepší skladatel? Dvořak nebo Smetana?“
Robot: „Vy jste zábavná! Počitači nemájí vkus. Nebudu odpovědět!
```

### Analysis

The system operates on music information as its single domain and is
mostly task-oriented. The tasks include getting answers to
music-related questions, getting music recommendations and playing
music, which are all initiated by the user. However, the system can
also be taught about music it doesn’t know, yet. In this case, the
system takes the initiative by asking the user about a band and its
releases for example. Additionally, the system has some
easter-egg-like features which amount to chit-chat instead of actually
getting a task done. This is shown in the last conversation, where the
user’s question presupposes that machines can have taste and the
system gives a snappy response.


## Exercise 3 (Minimum Edit Distance)

The script `edit_distance.py` uses Python and the `numpy` library to
calculate the minimum edit distance of two sentences. To use it, first
install `numpy`, if it’s not installed already:

```shell
$ pip install numpy
```

Then execute the `edit_distance.py` script with the gold sentence as
the first parameter and the hypothesis as the second parameter:

```shell
$ python3 edit_distance.py 'a a a' 'a b c a'
Edit Distance: 2
Alignment: nisn
Word Error Rate: 0.67
```

The file `test_edit_distance.py` contains the unit and integration
tests. It can be executed without arguments. Make sure that the
`edit_distance` module is importable, e.g. by executing
`test_edit_distance.py` from the directory `edit_distance.py` resides
in or setting the `PYTHONPATH` appropriately.

```shell
$ PYTHONPATH=/path/to/dir/with/edit_distance.py python3 test_edit_distance.py
..............
----------------------------------------------------------------------
Ran 14 tests in 0.001s

OK
```

### Exercise 6 (Training a Kaldi model)

It took me a lot of time to even install the Kaldi toolkit on the cluster I
have access to. The CPU nodes don’t have CUDA libraries, the GPU nodes don’t
have a GCC version with Fortran Libraries, and so on and so forth. I ended up
compiling it without CUDA. Also, ATLAS was not available, either, so I compiled
OpenBLAS.

At first I tried to use the 2016 version of the Vystadial data, but I
encountered some problems, e.g. that version does not include the `arpa_bigram`
file. So, I used the 2014 data that the script
`kaldi/egs/vystadial_cz/s5b/run.sh` downloads automatically.

To get everything running, I naturally had to change `path.sh` and `cmd.sh`,
most notably using Slurm as the Cluster manager and adding a `slurm.conf` file.

The output of the run script is provided in the accompanying log file. As I
compiled Kaldi without CUDA, I didn’t run stage 9 of the run script.

I’m not sure if I should provide anything other than that?

## Appendix

Exercise 1 took 45 minutes.

Exercise 2 took 140 minutes because I did it in Czech and had to look up
basically every word. I had fun, though! But I’m sure there are lots of errors
in the “conversation”.

Exercise 3 including the bonus questions took 110 minutes.

I didn’t measure the time for exercise 6, but it took me between 5 and 6 hours,
which was mostly due to problems with compiling. Also, compiling and running
both take a long time, but I could read the tutorial in that time.
