#!/usr/bin/env bash

DSTC2_TOP_DIR="$1"
OUTFILE="$2"

if [ -z "$DSTC2_TOP_DIR" -o -z "$OUTFILE" ]; then
    echo 'Usage: extract_dstc2.sh DSTC2_TOP_DIR OUTFILE'
    exit 1
elif [ ! -d "$DSTC2_TOP_DIR" ]; then
    echo "No such directory: $DSTC2_TOP_DIR"
    echo 'Usage: extract_dstc2.sh DSTC2_TOP_DIR OUTFILE'
    exit 2
fi

find "$DSTC2_TOP_DIR" -name 'log.json' | \
    while read -r fname; do
        sed -n 's/^[^"]*"transcript": "\(.*\)",\s*$/\1/p' "$fname" | awk '{ print tolower($0); }'
    done >"$OUTFILE"

# vim: sts=4 sw=4 et si
