#!/usr/bin/env bash

TOP_DIR="$1"
OUTFILE="$2"

if [ -z "$TOP_DIR" -o -z "$OUTFILE" ]; then
    echo 'Usage: extract_dstc2.sh TOP_DIR OUTFILE'
    exit 1
elif [ ! -d "$TOP_DIR" ]; then
    echo "No such directory: $TOP_DIR"
    echo 'Usage: extract_dstc2.sh TOP_DIR OUTFILE'
    exit 2
fi

shopt -s globstar
find "$TOP_DIR" -name '*.trn' -exec cat {} + | \
    sed 's/_INHALE_\|_LAUGH_\|_NOISE_\|_EHM_HMM_//g; s/ \+/ /g; s/^ \| $//g' | \
    grep -v '^\s*$' >"$OUTFILE"

# vim: sts=4 sw=4 et si
