#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import unittest

from entropy import get_entropy


class TestGetEntropy(unittest.TestCase):

    def test_empty(self):
        entropy = get_entropy([])
        self.assertIsNone(entropy)

    def test_normal_case(self):
        tokens = ['a', 'b', 'c', 'a', 'c', 'b', 'a', 'a']
        calculated_entropy = get_entropy(tokens)
        expected_entropy = 1.5
        self.assertEqual(calculated_entropy, expected_entropy)

    def test_no_signal(self):
        tokens = [7, 7, 7, 7, 7]
        calculated_entropy = get_entropy(tokens)
        expected_entropy = 0
        self.assertEqual(calculated_entropy, expected_entropy)
        

if __name__ == '__main__':
    unittest.main()
